import axios, {
    AxiosResponse,
    AxiosError
} from "../../node_modules/axios/index"; // Don't worry about red lines here ...

interface IPost {
    // attributes from http://jsonplaceholder.typicode.com/posts
    id: number;
    userId: number;
    title: string;
    body: string;
}

let element: HTMLDivElement = <HTMLDivElement>document.getElementById("content");

axios.get<IPost[]>("http://jsonplaceholder.typicode.com/posts")
    .then((response: AxiosResponse<IPost[]>) => {
        let data: IPost[] = response.data;
        element.innerHTML = JSON.stringify(data);
        data.forEach(element => {
           console.log(element.title);
        });
    })
    .catch((error: AxiosError) => {
        console.log(error);
        element.innerHTML = error.message;
    });


/////////////////////// axios - Med async/await //////////////////
//Bemærk kræver ES2018 derfor skal target i tsconfig.json ændres fra es6 til es2018//

const getPosts = async () => {
    try {
      return await axios.get<IPost[]>("http://jsonplaceholder.typicode.com/posts")
    } catch (error) {
      console.error(error);
      element.innerHTML = error.message;
    }
  }
  
  const PostsInfo = async () => {
    let posts = await getPosts();
  
    let data: IPost[] = posts.data;
        element.innerHTML = JSON.stringify(data);
        data.forEach(element => {
            console.log(element.title);
        });
    }

 PostsInfo();